local Gkp_raimainfirstShow = true;
UGKP_BUTTON_HEIGHT = 37;
UGKP_NUM_BIDS_TO_DISPLAY = 10;

Gkp_CurrentRaidId = 0;

UGKP_PARTY_STUFF = { };

function Ugkp_RaidMain_OnShow()
	if (Gkp_raimainfirstShow) then
		UgkpRaidMain_SelectTab(1);
		Gkp_raimainfirstShow = false;
	end;
end


function UgkpRaidMain_SelectTab(tab)
	PanelTemplates_SetTab(UgkpRaidBorderFrame, tab);
	local TabFrames = {
			[1] = "Ugkp_RaidFrame",
			[2] = "Ugkp_MemberFrame",
			[3] = "Ugkp_ItemFrame",
			[4] = "Ugkp_DkpFrame",
			[5] = "Ugkp_DistributeFrame",
			
		};
		for id, name in TabFrames do
		if (id == tab) then
			getglobal(name):Show();
		else
			getglobal(name):Hide();
		end
	end
	
end

function Ugkp_RaidMain_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("CHAT_MSG_LOOT");
	this:RegisterEvent("CHAT_MSG_SYSTEM");
	this:RegisterEvent("CHAT_MSG_WHISPER");
	this:RegisterEvent("RAID_ROSTER_UPDATE");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("OnEscapePressed");
	Ugkp_Debug(" register " , "load");
	PanelTemplates_SetNumTabs(UgkpRaidBorderFrame, 5);
	PanelTemplates_SetTab(UgkpRaidBorderFrame, 1);
	--init_raid();
	
	--UgkpRaidMain_SelectTab(tab)
end

function Ugkp_RaidMain_OnEvent(event)
	Ugkp_Debug("events", event);
	local t = date("*t");
	Ugkp_Debug("Gkp_CurrentRaidId",Gkp_CurrentRaidId);
	if ( (event == "RAID_ROSTER_UPDATE" or event == "PLAYER_ENTERING_WORLD") and Gkp_CurrentRaidId~=0 ) then	
		
			if(UGKP_PARTY_STUFF[UgkpRaid_GetCurrentRaid]["Status"]==1) then
				Ugkp_Member_Compute();
			end
		
	elseif ( (event == "CHAT_MSG_SYSTEM" or event == "RAID_ROSTER_UPDATE") and UnitName("player") and UnitName("player") ~= UgkpRaid_lang_UnknownEntity  and Gkp_CurrentRaidId~=0 ) then
		if(UGKP_PARTY_STUFF[UgkpRaid_GetCurrentRaid]["Status"]==1) then
			Ugkp_Member_Compute();
		end
	elseif ( event == "CHAT_MSG_LOOT" and Gkp_CurrentRaidId~=0) then
		if(UGKP_PARTY_STUFF[UgkpRaid_GetCurrentRaid]["Status"]==1) then
			local sPlayer, sLink;
			local iStart, iEnd, sPlayerName, sItem = string.find(arg1, UgkpRaid_lang_ReceivesLoot1);
			
			if ( sPlayerName ) then
				if(sPlayerName == UgkpRaid_lang_ReceivesLootYou) then
					sPlayer = UnitName("player");
				else	
					sPlayer = sPlayerName;
				end
				sLink = sItem;
			else
				local iStart, iEnd, sItem = string.find(arg1, UgkpRaid_lang_ReceivesLoot2);
				if ( sItem ) then
					sPlayer = UnitName("player");
					sLink = sItem;
				end
			end
			Ugkp_Debug(sLink,sPlayer);
			-- Make sure there is a link
			if ( sLink and sPlayer ) then
				local sColor, sItem, sName, sTooltip = Ugkp_GetItemInfo(sLink);
				Ugkp_Debug(sColor, sItem, sName);
				if ( sColor and sItem and sName  ) then
	
				 	if ( UgkpOptions.ItemQuality and UgkpRaid_RarityTable[sColor] >= UgkpOptions.ItemQuality ) then
						-- Insert into table
						local tt = date("*t");
						table.insert(UGKP_PARTY_STUFF[1]["Items"],1,
							{
								["tooltip"] = sTooltip,
								["player"] = sPlayer,				
								["c"] = sColor,
								["itemid"] =  UgkpGenId(),
								["name"] = sName,
								["cost"] = 0,
								["type"] = Ugkp_GetItemType("item:"..sItem),
								["time"] = Ugkp_Date(),
								["id"]=sItem,
								["pcost"]=getUgkpItemGKP(sName)
							}
						);
						UGKP_Tooltip:Hide();
					end
					
				end
				for k, v in sTooltip do
					Ugkp_Debug("tooltip", sItem, v["left"], v["right"]);
				end
				Ugkp_Debug(" loot item")
				Ugkp_UpdateItem();
			end
		end
	elseif ( event == "CHAT_MSG_WHISPER" ) then
		Ugkp_Debug(arg1);
		if( string.lower(arg1) == SYSTEM_QUERY_GKP) then
			--UgkpAnswerDkp(arg2);
		end
	elseif ( event == "VARIABLES_LOADED" ) then
			dkp_initialize();

			Ugkp_Raid_OnLoad();
			ugkp_rulerBodyEditBox:SetText(UgkpOptions.Ruler);
	end
	
end

function ugkp_CreateNewRaid()



	--UgkpRaid_Online = { };
	--UgkpRaid_Offline = { };
	--UgkpRaid_GatheredData_Temp = { };
	
	--UgkpRaid_HaveRaid = true;
	
	--Ugkp_Debug("UgkpRaid_GetCurrentRaid",UgkpRaid_GetCurrentRaid);
	local t=date("*t");
	
	--local sDate = t.year..""..t.month..""..t.day.." "..t.hour.."ʱ"..t.min.."";
	local sDate=Ugkp_Date();
	
	totalRaids=getn(UGKP_PARTY_STUFF);
	if(totalRaids>4) then
		UgkpRaidMessageBox(UGKP_MESSAGE_MAX_RAID);
		return;
	else
		Gkp_CurrentRaidId=UgkpGenId();
	end
	
	table.insert(UGKP_PARTY_STUFF,1, {
		["Id"]=Gkp_CurrentRaidId,
		["Members"] = { },
		["Items"] = { },
		["Events"] = { },
		["Notes"] = t.year.."-"..t.month,
		["RaidTime"] = Ugkp_Date(),
		["StartTime"] = "",
		["IntStartTime"] = time(),
		["EndTime"] = "",
		["RaidLeader"] = "",
		["Status"] = -1,
		["RaidMap"] = "",
		["Team"] = ""
	});
	
	UgkpRaid_GetCurrentRaid=UgkpGetCurentRaid();
	
	ShowUgkp_RaidFrameElement();
--	Ugkp_UpdateRaid();
	UgkpUpdateRaidList();
--	Ugkp_UpdateEvent();
	--Ugkp_UpdateMemberDkp();
	--Ugkp_UpdateMember();
	--Ugkp_UpdateItem();
	UgkpRaidMain_SelectTab(1);
	Ugkp_Raid_OnLoad();
	getglobal("UgkpRaidStatus_Edit".."Text"):SetText("|cff0070dd"..UGKP_MESSAGE_STATUS_CREATE.."|r");
	getglobal("Ugkp_RaidMap_Edit"):SetFocus();
end



function UgkpRaidMessageBox(...)

	
	local sDebug = "#";
	for i = 1, arg.n, 1 do
		if ( arg[i] ) then
			sDebug = sDebug .. arg[i] ;
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage(sDebug, 1, 0, 0);
	
end

function UgkpUpdateRaidList()

	local totalRaids = 0;
	for i=1,5 do
		getglobal("UgkpRaidFrameListButton"..i):Hide();
	end
	totalRaids=getn(UGKP_PARTY_STUFF);
	
	if( totalRaids> 0) then
	
		for i=1,totalRaids do
				getglobal("UgkpRaidFrameListButton"..i.."CheckId"):SetText(UGKP_PARTY_STUFF[i]["Id"]);
				getglobal("UgkpRaidFrameListButton"..i.."ButtonId"):SetText(UGKP_PARTY_STUFF[i]["Id"]);
				getglobal("UgkpRaidFrameListButton"..i.."ButtonName"):SetText(UGKP_PARTY_STUFF[i]["Notes"]);
				getglobal("UgkpRaidFrameListButton"..i):Show();
				Ugkp_Debug("UGKP_PARTY_STUFF[UgkpRaid_GetCurrentRaid]status"..UGKP_PARTY_STUFF[UgkpRaid_GetCurrentRaid]["Status"]);
			if(UGKP_PARTY_STUFF[UgkpRaid_GetCurrentRaid]["Status"]==2 or UGKP_PARTY_STUFF[UgkpRaid_GetCurrentRaid]["Status"]==3) then
				Ugkp_Debug("enable");
				getglobal("UgkpRaidFrameListButton"..i.."Button"):Enable();
				getglobal("UgkpRaidFrameListButton"..i.."ButtonName"):SetTextColor(84,80,81);
			else
				getglobal("UgkpRaidFrameListButton"..i.."Button"):Disable();
				getglobal("UgkpRaidFrameListButton"..i.."ButtonName"):SetTextColor(84,255,81);
				--getglobal("UgkpRaidFrameListButton"..i.."Name"):SetTextColor(84,80,81);
			end
			if(UGKP_PARTY_STUFF[i]["Id"]==Gkp_CurrentRaidId) then
				getglobal("UgkpRaidFrameListButton"..i.."ButtonName"):SetTextColor(0,255,0);
			end
		end
	end
end

function UgkpGenId()
	local tt=date("*t");
	local id=tt.month..tt.day..tt.hour..tt.min..tt.sec..GetTime();
	return id;
end

function UgkpGetCurentRaid()
	totalRaids=getn(UGKP_PARTY_STUFF);

	for i = 1, totalRaids  do
		if(UGKP_PARTY_STUFF[i]["Id"]==Gkp_CurrentRaidId) then
			return i;
		end
	end
	if(totalRaids>0) then
		return 1;
	else
		return 0
	end
end

function UgkpChangeRaid()
	
	RaidId= getglobal("UgkpRaidFrameListButton"..this:GetParent():GetID().."ButtonId"):GetText();
	Ugkp_Debug("RaidId"..RaidId.."Gkp_CurrentRaidId"..Gkp_CurrentRaidId);
	if(RaidId==Gkp_CurrentRaidId) then
		return;
	else
		Gkp_CurrentRaidId=RaidId;
		UgkpRaid_GetCurrentRaid=UgkpGetCurentRaid();
		UgkpUpdateRaidList();
	end
	Ugkp_Raid_OnLoad();
	UgkpUpdateRaidList();
	Ugkp_UpdateMember();
	Ugkp_UpdateEvent();
	Ugkp_UpdateItem();
	UgkpChangeButtonStatus();
	UgkpRaidMain_SelectTab(1);
	getglobal("UgkpRaidHeaderString"):SetText(UGKP_MESSAGE_RAID.."|cff1eff00"..UGKP_PARTY_STUFF[UgkpRaid_GetCurrentRaid]["Notes"].." |r");
end

function UgkpDeleteRaid()
	totalRaids=getn(UGKP_PARTY_STUFF);
	FlagDeleteCurrentRaid=false;
	if( totalRaids> 0) then
		for i=5,1 ,-1 do
			CheckRaid=getglobal("UgkpRaidFrameListButton"..i.."Check");
			
			if(CheckRaid:GetChecked()) then
				CheckId=getglobal("UgkpRaidFrameListButton"..i.."CheckId"):GetText();
				CheckRaid:SetChecked(false);
				for j=getn(UGKP_PARTY_STUFF),1,-1 do

					if(CheckId==UGKP_PARTY_STUFF[j]["Id"]) then
					table.remove(UGKP_PARTY_STUFF,j);
					end
				end
				
				
				if(CheckId==Gkp_CurrentRaidId) then
					FlagDeleteCurrentRaid=true;
				end
			end
		end
		if(FlagDeleteCurrentRaid and getn(UGKP_PARTY_STUFF)>0) then
			Gkp_CurrentRaidId=UGKP_PARTY_STUFF[1]["Id"];
			UgkpRaid_GetCurrentRaid=UgkpGetCurentRaid()
		elseif(getn(UGKP_PARTY_STUFF)<1) then
			Gkp_CurrentRaidId=0;
			UgkpRaid_GetCurrentRaid=0;
		end
	end
	
	UgkpUpdateRaidList();
	Ugkp_Raid_OnLoad();
end


function UgkpAnswerDkp(member)
	if(Gkp_CurrentRaidId~=0) then
		totalEvents = getn(UGKP_PARTY_STUFF[UgkpRaid_GetCurrentRaid]["Events"]);
		for k, v in UGKP_PARTY_STUFF[1]["Members"] do
			if( v["player"] == member ) then
				SendChatMessage(UGKP_IF_QUERY_DATA.." "..(v["dkp"]+getUgkpPlayerGKPLeft(v["player"])),"WHISPER", this.language, member);
				
				for i=totalEvents, 1,-1  do
					totalplayers=getn(UGKP_PARTY_STUFF[UgkpRaid_GetCurrentRaid]["Events"][i]["players"]);
					
					for j=totalplayers,1,-1 do
						
							if(UGKP_PARTY_STUFF[UgkpRaid_GetCurrentRaid]["Events"][i]["players"][j]==member) then
								SendChatMessage(SEND_GKP_MESSGE_EVENT..UGKP_PARTY_STUFF[UgkpRaid_GetCurrentRaid]["Events"][i]["reason"]..SEND_GKP_MESSGE_EVENT_CHANGE..UGKP_PARTY_STUFF[UgkpRaid_GetCurrentRaid]["Events"][i]["dkp"],"WHISPER", this.language, member);
								
							end
						
					end
				end
				SendChatMessage("------------------------------","WHISPER", this.language, member);
				SendChatMessage(UGKP_MESSAGE_DUNIU,"WHISPER", this.language, member);
				return;
			end
		end
		SendChatMessage(UGKP_NOT_QUERY_DATA,"WHISPER", this.language, member);
		SendChatMessage("------------------------------","WHISPER", this.language, member);
		SendChatMessage(UGKP_MESSAGE_DUNIU,"WHISPER", this.language, member);
	end
	return;
end

function Ugkp_GetItemInfo(sItem)
	-- Thanks to Telo for the following regular expression
	local iStart, iEnd, sColor, sItemName, sName = string.find(sItem, "|c(%x+)|Hitem:(%d+:%d+:%d+:%d+)|h%[(.-)%]|h|r");
	Ugkp_Debug(iStart, iEnd, sColor, sItemName, sName);
	if ( sColor and sItemName and sName ) then
		local tTooltip = { };
		for i = 1, 30, 1 do
			getglobal("UGKP_TooltipTextLeft" .. i):SetText("");
			getglobal("UGKP_TooltipTextLeft" .. i):Hide();
			getglobal("UGKP_TooltipTextRight" .. i):SetText("");
			getglobal("UGKP_TooltipTextRight" .. i):Hide();
		end
		
		UGKP_Tooltip:SetOwner(Ugkp_ItemFrame,"ANCHOR_NONE");
		UGKP_Tooltip:SetHyperlink("item:" .. sItemName);
		
		for i = 1, UGKP_Tooltip:NumLines(), 1 do
			local tl, tr;
			--if ( getglobal("UGKP_TooltipTextLeft" .. i):IsVisible() ) then
				tl = getglobal("UGKP_TooltipTextLeft" .. i):GetText();
			--end
			--if ( getglobal("UGKP_TooltipTextRight" .. i):IsVisible() ) then
				tr = getglobal("UGKP_TooltipTextRight" .. i):GetText();
			--end
			table.insert(tTooltip, { ["left"] = tl, ["right"] = tr });
		end
		UGKP_Tooltip:Hide();
		return sColor, sItemName, sName, tTooltip;
	end
end

function Ugkp_GetItemType(link)
	local udkptypes = UgkpRaid_lang_types;

	local special = UgkpRaid_lang_special;
	for i = 1, 30, 1 do
		getglobal("UGKP_TooltipTextLeft" .. i):SetText("");
		getglobal("UGKP_TooltipTextLeft" .. i):Hide();
		getglobal("UGKP_TooltipTextRight" .. i):SetText("");
		getglobal("UGKP_TooltipTextRight" .. i):Hide();
	end
	
	UGKP_Tooltip:SetOwner(Ugkp_ItemFrame,"ANCHOR_NONE");
	UGKP_Tooltip:SetHyperlink(link);
	--UGKP_Tooltip:Hide();
	for i = 2, min(UGKP_Tooltip:NumLines(), 5), 1 do
		local textleft = getglobal("UGKP_TooltipTextLeft" .. i);
		local textright = getglobal("UGKP_TooltipTextRight" .. i);
		
		
		if ( textleft and udkptypes[textleft:GetText()] ) then
			if ( ( textleft:GetText() == UgkpRaid_lang_OffHand or textleft:GetText() == UgkpRaid_lang_MainHand or textleft:GetText() == UgkpRaid_lang_OneHand or textleft:GetText() == UgkpRaid_lang_TwoHand ) and strlen(textright:GetText()) > 0 ) then
				if ( special[textright:GetText()] ) then
					if ( textleft:GetText() == UgkpRaid_lang_TwoHand ) then
						return UgkpRaid_lang_TwoHand.."-" .. textright:GetText();
					else
						
						return "Special-" .. textright:GetText();
					end
				else
					
					return textleft:GetText().."-Other";
				end
			else
				
				return textleft:GetText();
			end
		elseif ( textright and udkptypes[textright:GetText()] ) then
			
			return textright:GetText();
		end
	end
	
	return "Other";
end

function getUgkpItemGKP(sItem)
	if(itemlist) then
		if(itemlist[sItem]) then
			return itemlist[sItem];
		end
	end
	return 0;
end